diff --git a/Makefile b/Makefile
index 6bfb62cbe94..52d17ca7276 100644
--- a/Makefile
+++ b/Makefile
@@ -788,6 +788,7 @@ TEST_BUILTINS_OBJS += test-submodule-nested-repo-config.o
 TEST_BUILTINS_OBJS += test-submodule.o
 TEST_BUILTINS_OBJS += test-subprocess.o
 TEST_BUILTINS_OBJS += test-trace2.o
+TEST_BUILTINS_OBJS += test-tree-read-tree-at.o
 TEST_BUILTINS_OBJS += test-urlmatch-normalization.o
 TEST_BUILTINS_OBJS += test-userdiff.o
 TEST_BUILTINS_OBJS += test-wildmatch.o
diff --git a/t/helper/test-tool.c b/t/helper/test-tool.c
index d1d013bcd92..a8a9bedec5f 100644
--- a/t/helper/test-tool.c
+++ b/t/helper/test-tool.c
@@ -82,6 +82,7 @@ static struct test_cmd cmds[] = {
 	{ "submodule-nested-repo-config", cmd__submodule_nested_repo_config },
 	{ "subprocess", cmd__subprocess },
 	{ "trace2", cmd__trace2 },
+	{ "tree-read-tree-at", cmd__tree_read_tree_at },
 	{ "userdiff", cmd__userdiff },
 	{ "urlmatch-normalization", cmd__urlmatch_normalization },
 	{ "xml-encode", cmd__xml_encode },
diff --git a/t/helper/test-tool.h b/t/helper/test-tool.h
index 6b46b6444b6..409fddfaeb8 100644
--- a/t/helper/test-tool.h
+++ b/t/helper/test-tool.h
@@ -76,6 +76,7 @@ int cmd__submodule_config(int argc, const char **argv);
 int cmd__submodule_nested_repo_config(int argc, const char **argv);
 int cmd__subprocess(int argc, const char **argv);
 int cmd__trace2(int argc, const char **argv);
+int cmd__tree_read_tree_at(int argc, const char **argv);
 int cmd__userdiff(int argc, const char **argv);
 int cmd__urlmatch_normalization(int argc, const char **argv);
 int cmd__xml_encode(int argc, const char **argv);
diff --git a/t/helper/test-tree-read-tree-at.c b/t/helper/test-tree-read-tree-at.c
new file mode 100644
index 00000000000..bba759bb264
--- /dev/null
+++ b/t/helper/test-tree-read-tree-at.c
@@ -0,0 +1,40 @@
+/* This tests tree.c's read_tree / read_tree_at.
+We call it tree-read-tree-at to disambiguate with the read-tree tool.
+*/
+#include "cache.h"
+#include "pathspec.h"
+#include "test-tool.h"
+#include "tree.h"
+
+static int test_handle_entry(const struct object_id *oid,
+		struct strbuf *base, const char *filename,
+		unsigned mode, void *context UNUSED) {
+	printf("%i %s %s%s\n", mode, oid_to_hex(oid), base->buf, filename);
+	if (S_ISDIR(mode) || S_ISGITLINK(mode)) {
+		return READ_TREE_RECURSIVE;
+	}
+	return 0;
+}
+
+int cmd__tree_read_tree_at(int argc UNUSED, const char **argv)
+{
+	struct pathspec pathspec;
+	struct tree *tree;
+	struct repository *repo;
+	struct object_id oid;
+
+	setup_git_directory();
+	repo = the_repository;
+	assert(repo);
+
+	parse_pathspec(&pathspec, 0,
+		       PATHSPEC_PREFER_FULL,
+		       "", argv);
+
+	assert(repo_get_oid(repo, "HEAD", &oid) == 0);
+	tree = repo_parse_tree_indirect(repo, &oid);
+	assert(tree);
+	pathspec.recurse_submodules = 1;
+	read_tree(repo, tree, &pathspec, test_handle_entry, NULL);
+	return 0;
+}
diff --git a/t/t1023-tree-read-tree-at.sh b/t/t1023-tree-read-tree-at.sh
new file mode 100755
index 00000000000..9e5ce3abb4b
--- /dev/null
+++ b/t/t1023-tree-read-tree-at.sh
@@ -0,0 +1,65 @@
+#!/bin/sh
+
+# tests for tree.c (not read-tree.c)
+test_description='Test read_tree / read_tree_at'
+. ./test-lib.sh
+
+test_expect_success 'read_tree basic' '
+	rm -rf walk_tree_basic &&
+	git init walk_tree_basic &&
+	(
+		cd walk_tree_basic &&
+		set -x &&
+
+		mkdir -p dir1/dirA &&
+		mkdir -p dir1/dirB &&
+		mkdir -p dir2 &&
+		echo "file1" > file1.txt &&
+		echo "file2" > file2.txt &&
+		# uncommitted
+		echo "file3" > file3.txt &&
+
+		echo "file1A1" > dir1/dirA/file1.txt &&
+		git add file1.txt file2.txt dir1/dirA/file1.txt &&
+		git commit -m "initial commit" &&
+
+		test-tool tree-read-tree-at . > walk1.txt &&
+		grep " file1.txt" walk1.txt &&
+		! grep " file3.txt" walk1.txt &&
+		! grep " dir1/dirB" walk1.txt &&
+		grep " dir1/dirA/file1.txt" walk1.txt
+	)
+'
+
+test_expect_success 'read_tree submodules' '
+	rm -rf walk_tree_submodules &&
+	git init submodule1 &&
+	(
+		cd submodule1 &&
+		mkdir -p dir1/dirA &&
+		echo "dir2/sub1/file1.txt" > file1.txt &&
+		echo "dir2/sub1/file1A1.txt" > dir1/dirA/file1.txt &&
+		git add file1.txt dir1/dirA/file1.txt &&
+		git commit -m "initial commit"
+	) &&
+	git init walk_tree_submodules &&
+	(
+		cd walk_tree_submodules &&
+
+		mkdir -p dir2 &&
+		echo "file1" > file1.txt &&
+		echo "dir2/file2" > dir2/file2.txt &&
+		git add file1.txt dir2/file2.txt &&
+		git commit -m "initial commit" &&
+
+		git submodule add ../submodule1 dir2/sub1 &&
+		git commit -m "add submodule1" &&
+
+		test-tool tree-read-tree-at . > walk2.txt &&
+		grep " file1.txt" walk2.txt &&
+		grep " dir2/sub1/file1.txt" walk2.txt &&
+		grep " dir2/sub1/dir1/dirA/file1.txt" walk2.txt
+	)
+'
+
+test_done